#include <mega8.h>
#include <delay.h>

//  ________________________________________________________________________
interrupt[3] void ExtInt1(void) //    int1 ( D,  3 -   ).
   {                  // ,     int1.
                    
              
            if((PIND.0==0)&&(OCR2<0xff))
            {
            OCR2=OCR2+0x01;
            delay_ms(5);
            } 
    
            if((PIND.1==0)&&(OCR2>0x00))
            {
            OCR2=OCR2-0x01;
            delay_ms(5);
            }
           
            if(PIND.2==0)
            {
            PORTB=0B10100000;
            delay_ms(1);
            }

            if(PIND.4==0)
            {
            PORTB=0B10010000;
            delay_ms(1);
            }  
            
            if(PIND.5==0)
            {
            PORTB=0B01100000;
            delay_ms(1);
            }   
            
            if(PIND.6==0)
            {
            PORTB=0B01010000;
            delay_ms(1);
            }
                 
   }                               

//    __________________________________________________________________
void main(void)
{
DDRB=0b11111111;  //   B    (0-, 1-)
PORTB=0b00000000; //  B     
                    
                    
//DDRC=0b11111111;  //    C   
//PORTC=0b00000000; //   C     (  )


DDRD=0b00000000;  //   D    (0-, 1-)
PORTD=0b11111111; /*        D.
                    (0- , 1- ,     0  DDR    ) */  

GICR=0b10000000;  /*  General Interrupt Control Register   
                                      10 000000 -   int1;
                                      01 000000 -   into;
                                      11 000000 -    */

MCUCR=0b00001000; /*  Micro Controller Unit Control Registr    :
                                           0000 10 00 -       int1;
                                           0000 11 00 -       int1;
                                           0000 00 00 -      int1;
                                           0000 01 00 -       int1 */

#asm("sei")   //  SREG |= (1<<7);  Status Register, 7    .


//
                    ASSR=0b00000000;  
                    TCCR2=0x6C;       // . 
                    TCNT2=0b00000000;  
                    OCR2=0b00000000;  //  .
                    TIMSK=0b00000000;              


// ____________________________________________________________________________
  while(1)
    {   //   .      
    }   
}